searchNodes=[{"doc":"Utility functions making it easier to work with maps which can either have atom keys or string keys, but never both. For example, you'll find it useful when working with Ecto.Changeset , as Ecto.Changeset.cast/4 forbids passing maps with mixed key types. Nearly all functions mimic Map interface, e.g. MapWithIndifferentAccess.put/3 works just as Map.put/3 , with two important differences : You need to use atom keys when calling the functions. (Even if the map uses string keys.) If the map uses string keys, key argument will be converted to a string, and only then called with a respective Map function. Usage example Add map_with_indifferent_access to your list of dependencies in mix.exs : def deps do [ { :map_with_indifferent_access , &quot;~&gt; 1.0.0&quot; } ] end Use MapWithIndifferentAccess instead of Map , where you are interacting with a map that can have either string or atom keys: MapWithIndifferentAccess . get ( %{ a : 1 } , :a ) // # returns 1 MapWithIndifferentAccess . get ( %{ &quot;a&quot; =&gt; 1 } , :a ) // # returns 1 MapWithIndifferentAccess . put ( %{ a : 1 } , :b , 2 ) // # returns %{a: 1, b: 2} MapWithIndifferentAccess . put ( %{ &quot;a&quot; =&gt; 1 } , :b , 2 ) // # returns %{&quot;a&quot; =&gt; 1, &quot;b&quot; =&gt; 2} # Real world usage example defmodule ProductController do def create ( conn , params ) do params |&gt; MapWithIndifferentAccess . put ( :author_id , conn . assigns . current_user . id ) |&gt; ProductService . create ( ) end end defmodule AdminController do def create_test_product ( conn , params ) do %{ name : &quot;test product&quot; } |&gt; MapWithIndifferentAccess . put ( :author_id , conn . assigns . current_user . id ) |&gt; ProductService . create ( ) end end","ref":"MapWithIndifferentAccess.html","title":"MapWithIndifferentAccess","type":"module"},{"doc":"","ref":"MapWithIndifferentAccess.html#delete/2","title":"MapWithIndifferentAccess.delete/2","type":"function"},{"doc":"","ref":"MapWithIndifferentAccess.html#fetch!/2","title":"MapWithIndifferentAccess.fetch!/2","type":"function"},{"doc":"","ref":"MapWithIndifferentAccess.html#fetch/2","title":"MapWithIndifferentAccess.fetch/2","type":"function"},{"doc":"","ref":"MapWithIndifferentAccess.html#get/3","title":"MapWithIndifferentAccess.get/3","type":"function"},{"doc":"","ref":"MapWithIndifferentAccess.html#get_and_update!/3","title":"MapWithIndifferentAccess.get_and_update!/3","type":"function"},{"doc":"","ref":"MapWithIndifferentAccess.html#get_and_update/3","title":"MapWithIndifferentAccess.get_and_update/3","type":"function"},{"doc":"","ref":"MapWithIndifferentAccess.html#get_lazy/3","title":"MapWithIndifferentAccess.get_lazy/3","type":"function"},{"doc":"","ref":"MapWithIndifferentAccess.html#has_key?/2","title":"MapWithIndifferentAccess.has_key?/2","type":"function"},{"doc":"","ref":"MapWithIndifferentAccess.html#put/3","title":"MapWithIndifferentAccess.put/3","type":"function"},{"doc":"","ref":"MapWithIndifferentAccess.html#put_new/3","title":"MapWithIndifferentAccess.put_new/3","type":"function"},{"doc":"","ref":"MapWithIndifferentAccess.html#put_new_lazy/3","title":"MapWithIndifferentAccess.put_new_lazy/3","type":"function"},{"doc":"","ref":"MapWithIndifferentAccess.html#replace!/3","title":"MapWithIndifferentAccess.replace!/3","type":"function"},{"doc":"","ref":"MapWithIndifferentAccess.html#replace/3","title":"MapWithIndifferentAccess.replace/3","type":"function"},{"doc":"","ref":"MapWithIndifferentAccess.html#update!/3","title":"MapWithIndifferentAccess.update!/3","type":"function"},{"doc":"","ref":"MapWithIndifferentAccess.html#update/4","title":"MapWithIndifferentAccess.update/4","type":"function"},{"doc":"Tries to deduce if the map uses string keys. It does so by obtaining a random map key and verifying if it's a string. Thus, if a map contains mixed key types (both strings and atoms), it may return either true and false, randomly. We don't take it as a problem, as this module is not meant to be used with such maps. (It should be used only with maps where all keys are strings or all keys are atoms.)","ref":"MapWithIndifferentAccess.html#uses_string_keys?/1","title":"MapWithIndifferentAccess.uses_string_keys?/1","type":"function"},{"doc":"Utility functions making it easier to work with maps which can either have atom keys or string keys, but never both. For example, you'll find it useful when working with Ecto.Changeset , as Ecto.Changeset.cast/4 forbids passing maps with mixed key types. Nearly all functions mimic Map interface, e.g. MapWithIndifferentAccess.put/3 works just as Map.put/3 , with two important differences : You need to use atom keys when calling the functions. (Even if the map uses string keys.) If the map uses string keys, key argument will be converted to a string, and only then called with a respective Map function.","ref":"readme.html","title":"MapWithIndifferentAccess","type":"extras"},{"doc":"See API reference .","ref":"readme.html#usage-example","title":"MapWithIndifferentAccess - Usage example","type":"extras"},{"doc":"Running tests Run the following after cloning the repo: mix deps.get mix test","ref":"readme.html#contributing","title":"MapWithIndifferentAccess - Contributing","type":"extras"}]